name: Deploy db-migrations
run-name: ${{ github.actor }} deployed to build branch
on:
  push:
    branches:
      - main
    paths:
      - 'services/db-migrations/**'
      - '.gitea/workflows/deploy-service-db-migrations.yaml'
      - 'docker-compose.yml'

jobs:
  db-migrations:
    runs-on: ubuntu-latest

    env:
      COUCHDB_USER: ${{secrets.COUCHDB_USER}}
      COUCHDB_PASSWORD: ${{secrets.COUCHDB_PASSWORD}}

    steps:
      - uses: actions/checkout@v4
      - uses: actions/setup-node@v4
        with:
          node-version: '22'

      - name: install dependencies
        run: |
          corepack enable pnpm && corepack use pnpm@8.15.9
          pnpm --filter ./services/db-migrations deploy --prod build/service-db-migrations

      - name: build docker image
        run: DB_MIGRATIONS_TAG=commit-${{env.GITHUB_SHA}} docker compose -p hereconnect build db-migrations

      - name: start container
        run: DB_MIGRATIONS_TAG=commit-${{env.GITHUB_SHA}} docker compose -p hereconnect up --pull never db-migrations


      - name: cleanup docker image
        if: always()
        run: |
          docker compose -p hereconnect rm db-migrations --force --stop
          docker rmi hereconnect/service-db-migrations:commit-${{env.GITHUB_SHA}}
